#include <linux/bpf.h>
#include <linux/bpf_common.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>

#include "ebpf.h"
#include "bpf_insn.h"

int main() {
	int socks[2];

	srand(time(NULL));

	struct bpf_insn prog [] = {
		BPF_MOV32_IMM( BPF_REG_0, BPF_REG_0, 0, -1),
		BPF_EXIT_INSN(),
	};

	uint32_t insn_count = sizeof(prog)/sizeof(struct bpf_insn);

	int prog_fd = load_bpf_prog((void*)prog, insn_count);

	bool sock_ret = setup_sockets(prog_fd, socks);
	if (!sock_ret) // Failed to setup sockets
		return -2;

	char buf = 0;
	for(int i = 0; i < 1000; i++) {
		printf("%d\n", i);
		fflush(stdout);
		write(socks[1], &buf, 1);
	}

	printf("Terminating\n");
}
